'''
Aufgabe 1 (a)
'''
import matplotlib.pyplot as plt
import matplotlib.colors as colors
import numpy as np
import math
import time
import pgm



def padImage(image, model):
    
    h, w = image.shape
    mh, mw = model.shape
    mh2 = int(math.floor(mh / 2) + 1)
    mw2 = int(math.floor(mw / 2) + 1)

    result = np.zeros((h+mh, w+mw))
    result[mh2:h+mh2, mw2:w+mw2] = image
    
    return result



def spatialDomainCorrelationAt(image, w, h, model, x, y):
    
    mh, mw = model.shape
    imagePart = image[y:y+mh, x:x+mw] # Relevanten Bildteil holen
    imageMean = np.mean(imagePart) # Lokalen Durchschnitt berechnen
    imageCPart = imagePart - imageMean # Bildteil zentrieren (Durchschnitt abziehen)
      
    # Korrelationsformel aus dem Skript berechnen: 
    enumerator = np.sum(model * imageCPart) # Zaehler
    denominatorPart1 = np.sum(model * model) # Linker Faktor des Nenners
    denominatorPart2 = np.sum(imageCPart * imageCPart) # Rechter Faktor des Nenners   
    denominator = math.sqrt(denominatorPart1 * denominatorPart2) # Wurzel aus dem Produkt ziehen   
    cc = 0 if denominator == 0 else enumerator / denominator # Endlich: Korrelation berechnen
    return cc
    
    

def spatialDomainCorrelation(image, model):
    
    result = np.zeros_like(image) # Ergebnis-Bild anlegen
    image = padImage(image, model) # Bild padden mit Nullen
       
    modelMean = np.mean(model) # Modell Durchschnitt berechnen
    modelCentered = model - modelMean # Modell zentrieren (Durchschnitt abziehen)
    
    # Korrelation berechnen:
    h, w = result.shape
    for y in xrange(h):
        print "Working on row", y, "..."
        for x in xrange(w):
            result[y, x] = spatialDomainCorrelationAt(image, w, h, modelCentered, x, y)
   
    return result




def aufgabe1a():
    
    image = pgm.imread("shelf.pgm")
    model = pgm.imread("shelf-model3.pgm")
    
    start = time.time()
    result = spatialDomainCorrelation(image, model)
    end = time.time()
    print "Time taken to compute Correlation:", end - start
    
    resultThreshold = result.copy()
    resultThreshold[resultThreshold < 0.75 * np.max(resultThreshold)] = 0
    
    plt.figure(1)
    plt.subplot(221)
    plt.imshow(model, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(222)
    plt.imshow(image, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(223)
    plt.imshow(result, cmap=plt.cm.jet)
    plt.subplot(224)
    plt.imshow(resultThreshold, cmap=plt.cm.jet)
    plt.show()
    
    

aufgabe1a()
    
    
